<template>
  <div class="container mt-5">
    <h2>Cadastro de Técnicos</h2>
    <div class="panel-group">
      <div class="panel panel-default">
        <div class="card-header">
          <div class="form-group row">
            <div class="col-md-9">
              <input
                type="text"
                class="form-control"
                name="Nome"
                placeholder="Nome ou email"
                required
                v-model="stringBusca"
              />
            </div>
            <div class="col-md-3">
            <a class="btn btn-warning float-right" @click="buscar(stringBusca)">
              <i class="fas fa-search"></i>buscar
            </a>
            </div>
            <div class="card-body">
              <form @submit.prevent="salvar">
                <div class="form-group row">
                  <div class="col-lg-6">
                    <input
                      type="text"
                      class="form-control"
                      name="nome"
                      ref="nome"
                      v-model="tecnico.nome"
                      placeholder="nome"
                      required
                    />
                  </div>
                  <div class="col-lg-6">
                    <input
                      type="text"
                      class="form-control"
                      name="telefone"
                      ref="telefone"
                      v-model="tecnico.telefone"
                      placeholder="telefone"
                      required
                    />
                  </div>
                </div>
                <div class="form-group row">
                  <div class="col-lg-6">
                    <input
                      type="text"
                      class="form-control"
                      name="email"
                      v-model="tecnico.email"
                      placeholder="Email"
                      required
                    />
                  </div>

                  <div class="col-lg-6">
                    <input
                      type="text"
                      class="form-control"
                      name="cpf"
                      v-model="tecnico.cpf"
                      placeholder="cpf"
                      required
                    />
                  </div>
                </div>
                <div class="form-group row">
                  
                  <!-- <a class="btn btn-primary text-white float-right"  v-show="!tipo"  >
                      <i class="fas fa-sync"></i>Atualizar
                    </a> -->
                  <a
                    type="submit"
                    class="btn btn-success text-white float-right text-white"
                    value="Salvar"
                    @click="salvar()"
                  >
                    <i class="fas fa-plus-circle"></i>salvar
                  </a>
                </div>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>

    <table class="table table-striped mt-5">
      <thead>
        <tr>
          <th>ID</th>
          <th>Nome</th>
          <th>Email</th>
          <th>cpf</th>
          <th>telefone</th>
        </tr>
      </thead>

      <tbody>
        <tr v-for="tecnico in tecnicos" v-bind:key="tecnico.id">
          <td>{{ tecnico.id }}</td>
          <td>{{ tecnico.nome }}</td>
          <td>{{ tecnico.email }}</td>
          <td>{{ tecnico.cpf }}</td>
          <td>{{ tecnico.telefone }}</td>
          <td>
            <a
              data-toggle="collapse"
              href="'#' + tecnico.id"
              class="btn btn-sm btn-warning mx-1"
              @click="editar(tecnico.id)"
            >
              <i class="far fa-edit" title="Alterar"></i>
            </a>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import axios from "axios";

export default {
  data() {
    return {
      stringBusca: "",
      tecnicos: null,
      cor: null,
      checkKey: false,
      tecnico: {
        id: null,
        nome: null,
        email: null,
        cpf: null,
        senha: null,
        telefone: null,
      },
    };
  },
  methods: {
   
    listar() {
      axios
        .get(this.$MainURL + "/tecnicos", {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => (this.tecnicos = response.data));
    },
    buscar(nome) {
      if (!nome) {
        this.listar();
      } else {
        axios
          .get(this.$MainURL + "/tecnicos/" + nome)
          .then((response) => (this.tecnicos = response.data));
      }
    },
    salvar() {
      this.tecnico.senha = this.tecnico.cpf
      if (this.tecnico.id) {
        axios
          .put(this.$MainURL + "/tecnicos/" + this.tecnico.user_id, this.tecnico, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          // eslint-disable-next-line no-unused-vars
          .then((response) => {
            alert(`Ok, Alterado com sucesso`);
            this.listar();
            this.tecnico = {};

          });
      } else {
        
          axios
            .post(this.$MainURL + "/tecnicos", this.tecnico, {
              headers: {
                Authorization: `Bearer ${localStorage.getItem("token")}`,
              },
            })
            .then((response) => {
              alert(`Ok, cadastrado com ID: ${response.data.id}`);
              this.listar();
              this.tecnico = {};

            });
        
      }
    },
    editar(id) {
      axios
        .get(this.$MainURL + "/tecnicos/" + id, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => (this.tecnico = response.data));
      this.$refs.nome.focus();
    },

    sal(id) {
      setTimeout(() => {
        this.tecnico.id = id;
        this.axios
          .post(this.$MainURL + "/tecnicos", this.tecnicos, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then(this.GoBack());
      }, 3000);
    },
    GoBack() {
      window.history.length > 1 ? this.$router.go(-1) : this.$router.push("/");
    },
  },
  mounted() {
    this.listar();
  },
};
</script>

<style scoped></style>
